Index: gcc/testsuite/g++.dg/cpp1y/var-templ36.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/var-templ36.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/var-templ36.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,15 @@
+// { dg-do compile { target c++14 } }
+
+template <class T>
+constexpr T v = T();
+
+template <class T>
+constexpr T v<T*> = T();
+
+template <class T>
+struct A {
+  static constexpr decltype (v<T>) v = ::v<T>;
+};
+
+double d1 = v<double*>;
+double d2 = A<double*>::v;
Index: gcc/testsuite/g++.dg/cpp1y/constexpr-array1.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/constexpr-array1.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/constexpr-array1.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,20 @@
+// PR c++/67104
+// { dg-do compile { target c++14 } }
+
+template <typename T, int N> struct array
+{
+  constexpr T &operator[](int index) { return data[index]; }
+  constexpr T operator[](int index) const { return data[index]; }
+  T data[N];
+};
+
+constexpr array<long unsigned, 1001>
+make_bottle_count ()
+{
+  array<long unsigned, 1001> a{};
+  a[65] = 1;
+  return a;
+}
+
+constexpr auto bottle_count = make_bottle_count ();
+static_assert (bottle_count[65], "");
Index: gcc/testsuite/g++.dg/cpp1y/lambda-generic-ice4.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/lambda-generic-ice4.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/lambda-generic-ice4.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,10 @@
+// PR c++/67369
+// { dg-do compile { target c++14 } }
+
+int main() {
+  unsigned const nsz = 0;
+  auto repeat_conditional = [&](auto) {
+    auto new_sz = nsz;
+  };
+  repeat_conditional(1);
+}
Index: gcc/testsuite/g++.dg/cpp1y/var-templ33.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/var-templ33.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/var-templ33.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,20 @@
+// Test for variable templates in pack expansion
+// { dg-do compile { target c++14 } }
+
+template <int I> const int Val = I;
+
+constexpr int f () { return 0; }
+template <class T, class ...Ts>
+constexpr int f(T t, Ts... ts)
+{
+  return t + f(ts...);
+}
+
+template <int... Is>
+constexpr int g()
+{
+  return f(Val<Is>...);
+}
+
+#define SA(X) static_assert((X),#X)
+SA((g<1,2,3,4>() == 1+2+3+4));
Index: gcc/testsuite/g++.dg/cpp1y/var-templ37.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/var-templ37.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/var-templ37.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,23 @@
+// PR c++/65195
+// { dg-do compile { target c++14 } }
+
+template<typename T>
+T constant {};
+
+template<typename T>
+struct foo {
+    int operator()() const
+    { return 3; }
+};
+
+template<typename T>
+auto& f = constant<foo<T>>;
+
+int main()
+{
+    // fine
+    auto& ref = f<int>; ref();
+
+    // error: f<int> cannot be used as a function
+    f<int>();
+}
Index: gcc/testsuite/g++.dg/cpp1y/var-templ42.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/var-templ42.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/var-templ42.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,17 @@
+// PR c++/67131
+// { dg-do compile { target c++14 } }
+
+template <typename T> typename T::_ type;
+template <template <typename...> class> struct A;
+template <template <typename> class f> A<f> metafunction;
+namespace detail {
+template <typename> struct _decltype;
+}
+template <template <typename...> class F> struct A {
+  template <typename... T>
+  auto operator()() -> decltype(type<F<detail::_decltype<T>...>>);
+};
+template <typename F> auto valid_call(F f) -> decltype(f());
+constexpr auto valid_call(...) { return 0; }
+template <typename> struct no_type;
+static_assert(!valid_call(metafunction<no_type>),""); // { dg-error "" }
Index: gcc/testsuite/g++.dg/cpp1y/var-templ38.C
===================================================================
--- gcc/testsuite/g++.dg/cpp1y/var-templ38.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/cpp1y/var-templ38.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,9 @@
+// PR c++/66596
+// { dg-do compile { target c++14 } }
+
+struct U { void f() {} };
+struct V { void f() {} };
+template<class T> U t;
+template<> V t<int>;
+template<class T> void g() { t<T>.f(); }
+int main() { g<int>(); }
Index: gcc/testsuite/g++.dg/abi/abi-tag15.C
===================================================================
--- gcc/testsuite/g++.dg/abi/abi-tag15.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/abi/abi-tag15.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,3 @@
+// PR c++/66748
+
+enum __attribute__((abi_tag("foo"))) E {}; // { dg-error "redeclaration of" }
Index: gcc/testsuite/g++.dg/gomp/pr67504.C
===================================================================
--- gcc/testsuite/g++.dg/gomp/pr67504.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/gomp/pr67504.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,15 @@
+// PR c++/67504
+// { dg-do compile }
+// { dg-options "-fopenmp" }
+
+int bar (int);
+double bar (double);
+
+template <typename T>
+void
+foo (T x)
+{
+  #pragma omp for collapse (x + 1) // { dg-error "collapse argument needs positive constant integer expression" }
+  for (int i = 0; i < 10; i++)
+    ;
+}
Index: gcc/testsuite/g++.dg/gomp/pr67522.C
===================================================================
--- gcc/testsuite/g++.dg/gomp/pr67522.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/gomp/pr67522.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,26 @@
+// PR c++/67522
+// { dg-do compile }
+// { dg-options "-fopenmp" }
+
+struct S;
+
+template <int N>
+void
+foo (void)
+{
+  #pragma omp simd linear (S)			// { dg-error "is not a variable in clause" }
+  for (int i = 0; i < 16; i++)
+    ;
+
+  #pragma omp target map (S[0:10])		// { dg-error "is not a variable in" }
+  ;
+
+  #pragma omp task depend (inout: S[0:10])	// { dg-error "is not a variable in" }
+  ;
+}
+
+void
+bar ()
+{
+  foo <0> ();
+}
Index: gcc/testsuite/g++.dg/gomp/pr67514.C
===================================================================
--- gcc/testsuite/g++.dg/gomp/pr67514.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/gomp/pr67514.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,30 @@
+// PR c++/67514
+// { dg-do compile }
+// { dg-options "-fopenmp" }
+
+template <class T>
+void
+foo (T x, T y)
+{
+  #pragma omp parallel
+  #pragma omp for simd
+  for (T i = x; i < y; ++i)
+    ;
+  #pragma omp parallel
+  #pragma omp for simd collapse (2)
+  for (T i = x; i < y; ++i)
+    for (T j = x; j < y; j++)
+      ;
+}
+
+void
+bar (int *x, int *y)
+{
+  foo (x, y);
+}
+
+void
+baz (int x, int y)
+{
+  foo (x, y);
+}
Index: gcc/testsuite/g++.dg/gomp/pr67523.C
===================================================================
--- gcc/testsuite/g++.dg/gomp/pr67523.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/gomp/pr67523.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,29 @@
+// PR c++/67523
+// { dg-do compile }
+// { dg-options "-fopenmp" }
+
+struct S { int s; };
+
+template <typename T>
+void foo (T &x, T &y)
+{
+#pragma omp for simd
+  for (T i = x; i < y; i++)	// { dg-error "used with class iteration variable" }
+    ;
+#pragma omp parallel for simd
+  for (T i = x; i < y; i++)	// { dg-error "used with class iteration variable" }
+    ;
+#pragma omp target teams distribute parallel for simd
+  for (T i = x; i < y; i++)	// { dg-error "used with class iteration variable" }
+    ;
+#pragma omp target teams distribute simd
+  for (T i = x; i < y; i++)	// { dg-error "used with class iteration variable" }
+    ;
+}
+
+void
+bar ()
+{
+  S x, y;
+  foo <S> (x, y);
+}
Index: gcc/testsuite/g++.dg/gomp/pr67511.C
===================================================================
--- gcc/testsuite/g++.dg/gomp/pr67511.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/gomp/pr67511.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,20 @@
+// PR c++/67511
+// { dg-do compile }
+// { dg-options "-fopenmp" }
+
+struct I
+{
+  I ();
+  I (const I &);
+  I &operator++ ();
+  bool operator< (const I &) const;
+};
+__PTRDIFF_TYPE__ operator- (const I &, const I &);
+
+void
+foo (I &x, I &y)
+{
+#pragma omp for
+  for (I i = x; i < y; ++i)	// { dg-error "no match for" }
+    ;
+}
Index: gcc/testsuite/g++.dg/init/pr66857.C
===================================================================
--- gcc/testsuite/g++.dg/init/pr66857.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/init/pr66857.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,19 @@
+// PR c++/66857
+// { dg-do run }
+
+const int i = 0;
+
+struct Test
+{
+  Test (const int &rhs)
+  {
+    if (&rhs != &i)
+      __builtin_abort ();
+  }
+};
+
+int
+main (void)
+{
+  Test test = i;
+}
Index: gcc/testsuite/g++.dg/conversion/access1.C
===================================================================
--- gcc/testsuite/g++.dg/conversion/access1.C	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/testsuite/g++.dg/conversion/access1.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -15,7 +15,7 @@
 struct C : public P
 {
   // C can access P's copy ctor, but can't convert b to const P&.
-  C(const B& b) : P(b) {}	// { dg-error "inaccessible base" }
+  C(const B& b) : P(b) {}	// { dg-error "inaccessible base" "" { xfail *-*-* } }
 };
 
 void foo()
Index: gcc/testsuite/g++.dg/lto/pr66705_0.C
===================================================================
--- gcc/testsuite/g++.dg/lto/pr66705_0.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/lto/pr66705_0.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,15 @@
+// { dg-lto-do link }
+// { dg-lto-options { { -O2 -flto -flto-partition=max -fipa-pta } } }
+// { dg-extra-ld-options "-r -nostdlib" }
+
+class A {
+public:
+    A();
+};
+int a = 0;
+void foo() {
+    a = 0;
+    A b;
+    for (; a;)
+      ;
+}
Index: gcc/testsuite/g++.dg/warn/deprecated-9.C
===================================================================
--- gcc/testsuite/g++.dg/warn/deprecated-9.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/warn/deprecated-9.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+// PR c++/65974
+// { dg-options "-Wdeprecated" }
+
+struct S {
+    void bar();
+
+    __attribute__((deprecated("use bar() instead.")))
+    virtual void foo();
+};
+
+void S::foo() { bar(); }
+
+int main()
+{
+    return 0;
+}
Index: gcc/testsuite/g++.dg/pr66866.C
===================================================================
--- gcc/testsuite/g++.dg/pr66866.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/pr66866.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,29 @@
+// { dg-do run { target i?86-*-* x86_64-*-* } }
+// { dg-require-effective-target sse2_runtime }
+// { dg-options "-O -msse2" }
+
+extern "C" void abort (void);
+
+typedef long long __m128i __attribute__ ((__vector_size__ (16), __may_alias__));
+typedef short A __attribute__((__may_alias__));
+
+__m128i __attribute__((noinline))
+shuf(const __m128i v)
+{
+  __m128i r;
+
+  reinterpret_cast<A *>(&r)[5] = reinterpret_cast<const A *>(&v)[4];
+  return r;
+}
+
+int main()
+{
+  __attribute__((aligned(16))) short mem[8] = { 0, 1, 2, 3, 4, 5, 6, 7 };
+
+  *reinterpret_cast<__m128i *>(mem) = shuf (*reinterpret_cast<__m128i *>(mem));
+
+  if (mem[5] != 4)
+    abort ();
+
+  return 0;
+}
Index: gcc/testsuite/g++.dg/inherit/access9.C
===================================================================
--- gcc/testsuite/g++.dg/inherit/access9.C	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/inherit/access9.C	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,14 @@
+// PR c++/66957
+
+class BaseClass {
+protected:
+  static int x;
+};
+
+struct DerivedA : BaseClass { };
+
+struct DerivedB : BaseClass {
+  DerivedB() {
+    (void) DerivedA::x;
+  }
+};
Index: gcc/testsuite/c-c++-common/ubsan/pr66908.c
===================================================================
--- gcc/testsuite/c-c++-common/ubsan/pr66908.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/c-c++-common/ubsan/pr66908.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,15 @@
+/* PR sanitizer/66908 */
+/* { dg-do compile } */
+/* { dg-options "-fsanitize=shift,bounds -O2 -Werror=maybe-uninitialized" } */
+/* { dg-additional-options "-std=gnu90" { target c } } */
+
+struct S { int a[22]; };
+static int const e[22] = { };
+
+void
+foo (struct S const *s, unsigned int m, unsigned int *res)
+{
+  unsigned int i;
+  for (i = 0; i < 22; ++i)
+    res[i] = ((s->a[i] + e[i]) << m);
+}
Index: gcc/testsuite/c-c++-common/gomp/pr67501.c
===================================================================
--- gcc/testsuite/c-c++-common/gomp/pr67501.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/c-c++-common/gomp/pr67501.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,12 @@
+/* PR c/67501 */
+/* { dg-do compile } */
+/* { dg-options "-fopenmp" } */
+
+void
+foo (void)
+{
+  int i, j;
+  #pragma omp for simd copyprivate(j	/* { dg-error "before end of line" } */
+  for (i = 0; i < 16; ++i)		/* { dg-error "is not valid for" "" { target *-*-* } 9 } */
+    ;
+}
Index: gcc/testsuite/c-c++-common/gomp/pr67502.c
===================================================================
--- gcc/testsuite/c-c++-common/gomp/pr67502.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/c-c++-common/gomp/pr67502.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,16 @@
+/* PR c/67502 */
+/* { dg-do compile } */
+/* { dg-options "-fopenmp" } */
+/* { dg-additional-options "-std=c99" { target c } } */
+
+void bar (int, int);
+
+void
+foo (void)
+{
+#pragma omp parallel
+#pragma omp for simd collapse(2)
+  for (int i = 0; i < 16; ++i)
+    for (int j = 0; j < 16; ++j)
+      bar (i, j);
+}
Index: gcc/testsuite/c-c++-common/gomp/pr67521.c
===================================================================
--- gcc/testsuite/c-c++-common/gomp/pr67521.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/c-c++-common/gomp/pr67521.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,20 @@
+/* PR middle-end/67521 */
+/* { dg-do compile } */
+/* { dg-options "-fopenmp" } */
+
+void
+foo (int x)
+{
+  int i = 0;
+  #pragma omp parallel for simd
+  for (i = (i & x); i < 10; i = i + 2)
+    ;
+  i = 0;
+  #pragma omp parallel for simd
+  for (i = 0; i < (i & x) + 10; i = i + 2)
+    ;
+  i = 0;
+  #pragma omp parallel for simd
+  for (i = 0; i < 10; i = i + ((i & x) + 2))
+    ;
+}
Index: gcc/testsuite/c-c++-common/gomp/pr67517.c
===================================================================
--- gcc/testsuite/c-c++-common/gomp/pr67517.c	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ gcc/testsuite/c-c++-common/gomp/pr67517.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,13 @@
+/* PR middle-end/67517 */
+/* { dg-do compile } */
+/* { dg-options "-fopenmp" } */
+
+int
+foo (int x, int y, int z)
+{
+  int i;
+  #pragma omp parallel for simd linear (y : x & 15) linear (x : 16) linear (z : x & 15)
+  for (i = 0; i < 256; ++i)
+    x += 16, y += x & 15, z += x & 15;
+  return x + y + z;
+}
Index: gcc/cp/class.c
===================================================================
--- gcc/cp/class.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/class.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1989,6 +1989,10 @@
   if (!t)
     return;
 
+  tree attrs = TYPE_ATTRIBUTES (t);
+  unsigned align = TYPE_ALIGN (t);
+  bool user_align = TYPE_USER_ALIGN (t);
+
   for (variants = TYPE_NEXT_VARIANT (t);
        variants;
        variants = TYPE_NEXT_VARIANT (variants))
@@ -1995,8 +1999,13 @@
     {
       /* These are the two fields that check_qualified_type looks at and
 	 are affected by attributes.  */
-      TYPE_ATTRIBUTES (variants) = TYPE_ATTRIBUTES (t);
-      TYPE_ALIGN (variants) = TYPE_ALIGN (t);
+      TYPE_ATTRIBUTES (variants) = attrs;
+      unsigned valign = align;
+      if (TYPE_USER_ALIGN (variants))
+	valign = MAX (valign, TYPE_ALIGN (variants));
+      else
+	TYPE_USER_ALIGN (variants) = user_align;
+      TYPE_ALIGN (variants) = valign;
     }
 }
 
Index: gcc/cp/constexpr.c
===================================================================
--- gcc/cp/constexpr.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/constexpr.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1750,8 +1750,39 @@
       VERIFY_CONSTANT (ary);
       gcc_unreachable ();
     }
-  if (compare_tree_int (index, len) >= 0)
+
+  i = tree_to_shwi (index);
+  bool found = true;
+  if (TREE_CODE (ary) == CONSTRUCTOR && len
+      && (TREE_CODE (CONSTRUCTOR_ELT (ary, len-1)->index) == RANGE_EXPR
+	  || compare_tree_int (CONSTRUCTOR_ELT (ary, len-1)->index, len-1)))
     {
+      /* The last element doesn't match its position in the array; this must be
+	 a sparse array from cxx_eval_store_expression.  So iterate.  */
+      found = false;
+      vec<constructor_elt, va_gc> *v = CONSTRUCTOR_ELTS (ary);
+      constructor_elt *e;
+      for (unsigned ix = 0; vec_safe_iterate (v, ix, &e); ++ix)
+	{
+	  if (TREE_CODE (e->index) == RANGE_EXPR)
+	    {
+	      tree lo = TREE_OPERAND (e->index, 0);
+	      tree hi = TREE_OPERAND (e->index, 1);
+	      if (tree_int_cst_le (lo, index) && tree_int_cst_le (index, hi))
+		found = true;
+	    }
+	  else if (tree_int_cst_equal (e->index, index))
+	    found = true;
+	  if (found)
+	    {
+	      i = ix;
+	      break;
+	    }
+	}
+    }
+
+  if (i >= len || !found)
+    {
       if (tree_int_cst_lt (index, array_type_nelts_top (TREE_TYPE (ary))))
 	{
 	  /* If it's within the array bounds but doesn't have an explicit
@@ -1767,7 +1798,7 @@
       *non_constant_p = true;
       return t;
     }
-  else if (tree_int_cst_lt (index, integer_zero_node))
+  else if (i < 0)
     {
       if (!ctx->quiet)
 	error ("negative array subscript");
@@ -1774,7 +1805,7 @@
       *non_constant_p = true;
       return t;
     }
-  i = tree_to_shwi (index);
+
   if (TREE_CODE (ary) == CONSTRUCTOR)
     return (*CONSTRUCTOR_ELTS (ary))[i].value;
   else if (elem_nchars == 1)
Index: gcc/cp/error.c
===================================================================
--- gcc/cp/error.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/error.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1230,7 +1230,8 @@
 	if (args == error_mark_node)
 	  pp_string (pp, M_("<template arguments error>"));
 	else if (args)
-	  dump_template_argument_list (pp, args, flags);
+	  dump_template_argument_list
+	    (pp, args, flags|TFF_NO_OMIT_DEFAULT_TEMPLATE_ARGUMENTS);
       	pp_cxx_end_template_argument_list (pp);
       }
       break;
Index: gcc/cp/tree.c
===================================================================
--- gcc/cp/tree.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/tree.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -3602,13 +3602,15 @@
 		 name, *node);
 	  goto fail;
 	}
-      else if (CLASSTYPE_TEMPLATE_INSTANTIATION (*node))
+      else if (CLASS_TYPE_P (*node)
+	       && CLASSTYPE_TEMPLATE_INSTANTIATION (*node))
 	{
 	  warning (OPT_Wattributes, "ignoring %qE attribute applied to "
 		   "template instantiation %qT", name, *node);
 	  goto fail;
 	}
-      else if (CLASSTYPE_TEMPLATE_SPECIALIZATION (*node))
+      else if (CLASS_TYPE_P (*node)
+	       && CLASSTYPE_TEMPLATE_SPECIALIZATION (*node))
 	{
 	  warning (OPT_Wattributes, "ignoring %qE attribute applied to "
 		   "template specialization %qT", name, *node);
Index: gcc/cp/ChangeLog
===================================================================
--- gcc/cp/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/ChangeLog	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,3 +1,119 @@
+2015-09-10  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c++/67522
+	* semantics.c (handle_omp_array_sections_1): Only run
+	type_dependent_expression_p on VAR_DECL/PARM_DECLs.
+	(finish_omp_clauses) <case OMP_CLAUSE_LINEAR>: Likewise.
+	Don't adjust OMP_CLAUSE_LINEAR_STEP if OMP_CLAUSE_DECL
+	is not a VAR_DECL/PARM_DECL.
+
+	PR c++/67511
+	* semantics.c (handle_omp_for_class_iterator): Don't wrap
+	error_mark_node into a NOP_EXPR to void_type_node.
+
+2015-09-09  Jakub Jelinek  <jakub@redhat.com>
+
+	PR c++/67504
+	* parser.c (cp_parser_omp_clause_collapse): Test tree_fits_shwi_p
+	before INTEGRAL_TYPE_P test.
+
+2015-09-08  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR c++/67369
+	* pt.c (tsubst_copy, [case FUNCTION_DECL]): Do not call tsubst
+	if the first argument isn't a template.
+
+2015-08-17  Jason Merrill  <jason@redhat.com>
+
+	PR c++/66957
+	* search.c (protected_accessible_p): Revert fix for 38579.
+
+2015-08-17  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR c++/66919
+	* pt.c (tsubst_copy): Pass complain to mark_used, check return value.
+
+2015-08-17  Jason Merrill  <jason@redhat.com>
+
+	PR c++/67244
+	* pt.c (tsubst_copy_and_build): Call insert_pending_capture_proxies.
+
+	PR c++/65734
+	* class.c (fixup_attribute_variants): Respect TYPE_USER_ALIGN.
+
+	PR c++/67104
+	* constexpr.c (cxx_eval_array_reference): Handle sparse
+	CONSTRUCTORs.
+
+2015-08-14  Jason Merrill  <jason@redhat.com>
+
+	PR c++/65974
+	* decl2.c (mark_vtable_entries): Suppress -Wdeprecated.
+
+2015-08-14  Patrick Palka  <ppalka@gcc.gnu.org>
+
+	PR c++/66857
+	* cvt.c (ocp_convert): Don't call scalar_constant_value when
+	converting to a class type.
+
+2015-08-12  Jason Merrill  <jason@redhat.com>
+
+	PR c++/67161
+	* error.c (dump_decl) [TEMPLATE_ID_EXPR]: Pass
+	TFF_NO_OMIT_DEFAULT_TEMPLATE_ARGUMENTS.
+
+2015-08-06  Jason Merrill  <jason@redhat.com>
+
+	PR c++/66533
+	* parser.c (cp_parser_primary_expression): Don't skip to the end
+	of the statement if we're parsing tentatively.
+
+	PR c++/67130
+	PR c++/67131
+	PR c++/66260
+	* mangle.c (write_expression) [TEMPLATE_ID_EXPR]: Handle variable
+	templates.
+	* pt.c (tsubst_copy_and_build): Check for argument substitution
+	failure.
+
+2015-08-05  Jason Merrill  <jason@redhat.com>
+
+	PR c++/66260
+	PR c++/66596
+	PR c++/66649
+	PR c++/66923
+	* pt.c (lookup_template_variable): Use NULL_TREE for type.
+	(instantiate_template_1): Also set DECL_TI_ARGS based on
+	the immediate parent.
+	(tsubst_copy_and_build) [TEMPLATE_ID_EXPR]: Handle variable templates.
+	(finish_template_variable): Add complain parm.
+	* cp-tree.h: Adjust.
+
+	PR c++/65195
+	PR c++/66619
+	* semantics.c (finish_id_expression): Call convert_from_reference
+	for variable template.
+
+	PR c++/66336
+	* pt.c (find_parameter_packs_r): Handle variable templates.
+	(variable_template_specialization_p): New.
+	* cp-tree.h: Declare it.
+
+2015-07-30  Jason Merrill  <jason@redhat.com>
+
+	DR 1558
+	PR c++/67021
+	* pt.c (tsubst_decl) [TYPE_DECL]: Clear TYPE_DEPENDENT_P_VALID.
+
+2015-07-16  Marek Polacek  <polacek@redhat.com>
+
+	Backported from mainline
+	2015-07-08  Marek Polacek  <polacek@redhat.com>
+
+	PR c++/66748
+	* tree.c (handle_abi_tag_attribute): Check for CLASS_TYPE_P before
+	accessing TYPE_LANG_SPECIFIC node.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: gcc/cp/pt.c
===================================================================
--- gcc/cp/pt.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/pt.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -3222,6 +3222,13 @@
 			ppd, ppd->visited);
 	  *walk_subtrees = 0;
 	}
+      else if (variable_template_specialization_p (t))
+	{
+	  cp_walk_tree (&DECL_TI_ARGS (t),
+			find_parameter_packs_r,
+			ppd, ppd->visited);
+	  *walk_subtrees = 0;
+	}
       break;
 
     case BASES:
@@ -5323,6 +5330,17 @@
   return instantiate_non_dependent_expr_sfinae (expr, tf_error);
 }
 
+/* True iff T is a specialization of a variable template.  */
+
+bool
+variable_template_specialization_p (tree t)
+{
+  if (!VAR_P (t) || !DECL_LANG_SPECIFIC (t) || !DECL_TEMPLATE_INFO (t))
+    return false;
+  tree tmpl = DECL_TI_TEMPLATE (t);
+  return variable_template_p (tmpl);
+}
+
 /* Return TRUE iff T is a type alias, a TEMPLATE_DECL for an alias
    template declaration, or a TYPE_DECL for an alias declaration.  */
 
@@ -8161,7 +8179,7 @@
 tree
 lookup_template_variable (tree templ, tree arglist)
 {
-  tree type = unknown_type_node;
+  tree type = NULL_TREE;
   return build2 (TEMPLATE_ID_EXPR, type, templ, arglist);
 }
 
@@ -8168,7 +8186,7 @@
 /* Instantiate a variable declaration from a TEMPLATE_ID_EXPR for use. */
 
 tree
-finish_template_variable (tree var)
+finish_template_variable (tree var, tsubst_flags_t complain)
 {
   tree templ = TREE_OPERAND (var, 0);
 
@@ -8177,7 +8195,6 @@
   arglist = add_outermost_template_args (tmpl_args, arglist);
 
   tree parms = DECL_TEMPLATE_PARMS (templ);
-  tsubst_flags_t complain = tf_warning_or_error;
   arglist = coerce_innermost_template_parms (parms, arglist, templ, complain,
 					     /*req_all*/true,
 					     /*use_default*/true);
@@ -11547,6 +11564,10 @@
 	  {
 	    DECL_ORIGINAL_TYPE (r) = NULL_TREE;
 	    set_underlying_type (r);
+	    if (TYPE_DECL_ALIAS_P (r) && type != error_mark_node)
+	      /* An alias template specialization can be dependent
+		 even if its underlying type is not.  */
+	      TYPE_DEPENDENT_P_VALID (TREE_TYPE (r)) = false;
 	  }
 
 	layout_decl (r, 0);
@@ -13089,8 +13110,9 @@
 	      if (r)
 		{
 		  /* Make sure that the one we found is the one we want.  */
-		  tree ctx = tsubst (DECL_CONTEXT (t), args,
-				     complain, in_decl);
+		  tree ctx = DECL_CONTEXT (t);
+		  if (DECL_LANG_SPECIFIC (ctx) && DECL_TEMPLATE_INFO (ctx))
+		    ctx = tsubst (ctx, args, complain, in_decl);
 		  if (ctx != DECL_CONTEXT (r))
 		    r = NULL_TREE;
 		}
@@ -13138,7 +13160,8 @@
 	}
       else
 	r = t;
-      mark_used (r);
+      if (!mark_used (r, complain) && !(complain & tf_error))
+	return error_mark_node;
       return r;
 
     case NAMESPACE_DECL:
@@ -14714,7 +14737,20 @@
 
 	if (targs)
 	  targs = tsubst_template_args (targs, args, complain, in_decl);
+	if (targs == error_mark_node)
+	  return error_mark_node;
 
+	if (variable_template_p (templ))
+	  {
+	    templ = lookup_template_variable (templ, targs);
+	    if (!any_dependent_template_arguments_p (targs))
+	      {
+		templ = finish_template_variable (templ, complain);
+		mark_used (templ);
+	      }
+	    RETURN (convert_from_reference (templ));
+	  }
+
 	if (TREE_CODE (templ) == COMPONENT_REF)
 	  {
 	    object = TREE_OPERAND (templ, 0);
@@ -15826,6 +15862,8 @@
 
 	LAMBDA_EXPR_THIS_CAPTURE (r) = NULL_TREE;
 
+	insert_pending_capture_proxies ();
+
 	RETURN (build_lambda_object (r));
       }
 
@@ -16112,6 +16150,8 @@
   /* The DECL_TI_TEMPLATE should always be the immediate parent
      template, not the most general template.  */
   DECL_TI_TEMPLATE (fndecl) = tmpl;
+  if (VAR_P (fndecl))
+    DECL_TI_ARGS (fndecl) = targ_ptr;
 
   /* Now we know the specialization, compute access previously
      deferred.  */
Index: gcc/cp/semantics.c
===================================================================
--- gcc/cp/semantics.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/semantics.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -3580,6 +3580,7 @@
 	{
 	  decl = finish_template_variable (decl);
 	  mark_used (decl);
+	  decl = convert_from_reference (decl);
 	}
       else if (scope)
 	{
@@ -4294,8 +4295,6 @@
     {
       if (error_operand_p (t))
 	return error_mark_node;
-      if (type_dependent_expression_p (t))
-	return NULL_TREE;
       if (TREE_CODE (t) != VAR_DECL && TREE_CODE (t) != PARM_DECL)
 	{
 	  if (processing_template_decl)
@@ -4318,6 +4317,8 @@
 		    omp_clause_code_name[OMP_CLAUSE_CODE (c)]);
 	  return error_mark_node;
 	}
+      if (type_dependent_expression_p (t))
+	return NULL_TREE;
       t = convert_from_reference (t);
       return t;
     }
@@ -5332,7 +5333,8 @@
 	  goto check_dup_generic;
 	case OMP_CLAUSE_LINEAR:
 	  t = OMP_CLAUSE_DECL (c);
-	  if (!type_dependent_expression_p (t)
+	  if ((VAR_P (t) || TREE_CODE (t) == PARM_DECL)
+	      && !type_dependent_expression_p (t)
 	      && !INTEGRAL_TYPE_P (TREE_TYPE (t))
 	      && TREE_CODE (TREE_TYPE (t)) != POINTER_TYPE)
 	    {
@@ -5359,7 +5361,9 @@
 	  else
 	    {
 	      t = mark_rvalue_use (t);
-	      if (!processing_template_decl)
+	      if (!processing_template_decl
+		  && (VAR_P (OMP_CLAUSE_DECL (c))
+		      || TREE_CODE (OMP_CLAUSE_DECL (c)) == PARM_DECL))
 		{
 		  if (TREE_CODE (OMP_CLAUSE_DECL (c)) == PARM_DECL)
 		    t = maybe_constant_value (t);
@@ -6452,7 +6456,8 @@
   iter_init = build_x_modify_expr (elocus,
 				   iter, PLUS_EXPR, iter_init,
 				   tf_warning_or_error);
-  iter_init = build1 (NOP_EXPR, void_type_node, iter_init);
+  if (iter_init != error_mark_node)
+    iter_init = build1 (NOP_EXPR, void_type_node, iter_init);
   finish_expr_stmt (iter_init);
   finish_expr_stmt (build_x_modify_expr (elocus,
 					 last, NOP_EXPR, decl,
Index: gcc/cp/decl2.c
===================================================================
--- gcc/cp/decl2.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/decl2.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1742,6 +1742,9 @@
   tree fnaddr;
   unsigned HOST_WIDE_INT idx;
 
+  /* It's OK for the vtable to refer to deprecated virtual functions.  */
+  warning_sentinel w(warn_deprecated_decl);
+
   FOR_EACH_CONSTRUCTOR_VALUE (CONSTRUCTOR_ELTS (DECL_INITIAL (decl)),
 			      idx, fnaddr)
     {
Index: gcc/cp/parser.c
===================================================================
--- gcc/cp/parser.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/parser.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -4432,7 +4432,8 @@
 	parser->greater_than_is_operator_p
 	  = saved_greater_than_is_operator_p;
 	/* Consume the `)'.  */
-	if (!cp_parser_require (parser, CPP_CLOSE_PAREN, RT_CLOSE_PAREN))
+	if (!cp_parser_require (parser, CPP_CLOSE_PAREN, RT_CLOSE_PAREN)
+	    && !cp_parser_uncommitted_to_tentative_parse_p (parser))
 	  cp_parser_skip_to_end_of_statement (parser);
 
 	return expr;
@@ -28181,8 +28182,8 @@
   if (num == error_mark_node)
     return list;
   num = fold_non_dependent_expr (num);
-  if (!INTEGRAL_TYPE_P (TREE_TYPE (num))
-      || !tree_fits_shwi_p (num)
+  if (!tree_fits_shwi_p (num)
+      || !INTEGRAL_TYPE_P (TREE_TYPE (num))
       || (n = tree_to_shwi (num)) <= 0
       || (int) n != n)
     {
Index: gcc/cp/cvt.c
===================================================================
--- gcc/cp/cvt.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/cvt.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -695,7 +695,8 @@
     }
 
   /* FIXME remove when moving to c_fully_fold model.  */
-  e = scalar_constant_value (e);
+  if (!CLASS_TYPE_P (type))
+    e = scalar_constant_value (e);
   if (error_operand_p (e))
     return error_mark_node;
 
Index: gcc/cp/mangle.c
===================================================================
--- gcc/cp/mangle.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ gcc/cp/mangle.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -2771,7 +2771,9 @@
     {
       tree fn = TREE_OPERAND (expr, 0);
       if (is_overloaded_fn (fn))
-	fn = DECL_NAME (get_first_fn (fn));
+	fn = get_first_fn (fn);
+      if (DECL_P (fn))
+	fn = DECL_NAME (fn);
       if (IDENTIFIER_OPNAME_P (fn))
 	write_string ("on");
       write_unqualified_id (fn);
